// O (N * logN)
#include <fstream>
#include <algorithm>
#include <string.h>
#include <vector>
using namespace std;

ifstream fin("berarii.in");
ofstream fout("berarii.out");

using ll = long long;
const int Nmax = 1e5 + 10, INF = 1e9;

int N, K, berarii;
int viz[Nmax];
int B[Nmax];   // B[x] = cantitatea de bere ceruta in x
ll Dmin[Nmax]; // Dmin[x] = distanta (actuala) de la x pana la cea mai apropiata berarie
ll Dmax[Nmax]; // Dmax[x] = distanta maxima (stabilita prin cautare binara) a unei berarii fata de x
ll D_Sus[Nmax];// D_Sus[x] = distanta maxima (IN SUS) la care ma pot indeparta de o berarie fata de nodul x (beraria era sub nodul x)
               // D_Sus[x] - cat a mai ramas din Dmax[x] dupa ce m-am indepartat de cea mai apropiata berarie

vector<pair<int, int>> G[Nmax];

void DFS(int x, int wt) // costul muchiei pe care am intrat in x dinspre tata
{
    viz[x] = 1;
    D_Sus[x] = Dmax[x];   // initial, din x pot urca distanta cel mult distanta Dmax[x]
    for (auto [y, w] : G[x])
        if (!viz[y])
        {
            DFS(y, w);
            D_Sus[x] = min(D_Sus[x], D_Sus[y] - w);     // nu pot urca mai sus decat imi permite fiul
            Dmin[x] = min(Dmin[x], Dmin[y] + w);  // fiul imi spune daca prin el exista o berarie mai apropiata
        }

    if (x == 1)
    {
        // daca nu pot sa ajung intr-o berarie o pun in radacina pentru ca n-am unde sa mai urc
        if (D_Sus[x] < Dmin[x])
			berarii++;
        return ;
    }

    if (D_Sus[x] >= Dmin[x])
    {
        // pot ajunge la o berarie, nu mai conteza nodul asta
        D_Sus[x] = INF;
    }
    else
    {
        // nu pot sa merg mai sus, pun o berarie in x
        if (D_Sus[x]  < wt) // nu pot sa urc muchia spre tata
        {
            D_Sus[x] = INF;
            Dmin[x] = 0;
            berarii++;
        }
    }
}

ll Cb()  // costul minim se cauta binar
{
    ll st = 0, dr = (ll)1e12, m, sol = 0;
    while (st <= dr)
    {
        m = (st + dr) >> 1;

        berarii = 0;
        for (int i = 1; i <= N; i++)
        {
            Dmin[i] = INF;
            D_Sus[i] = INF;
            Dmax[i] = m / B[i];    //  se fixeaza distantele care nu trebuie depasite pentru acest cost
            viz[i] = 0;
        }

        DFS(1, 0);

        if (berarii <= K)      // daca am folosit <= K berarii, incerc un cost total mai mic
        {
			sol = m;
			dr = m - 1;
		}
        else
			st = m + 1;
    }

    return sol;
}

int main()
{
	int T, x, y, w;
    fin >> T;
    while (T--)
    {
        fin >> N >> K;
        for (int i = 1; i <= N; ++i)
			fin >> B[i];

        for (int i = 1; i < N; ++i)
        {
            fin >> x >> y >> w;
            G[x].emplace_back(y, w);
            G[y].emplace_back(x, w);
        }

        fout << Cb() << '\n';

        for (int i = 1; i <= N; ++i)
            G[i].clear();
    }

    return 0;
}
