// O(n^3)
// OK
#include <stdio.h>
#include <vector>
#include <string.h>
#include <time.h>

using namespace std;

const int MaxN = 128;
vector<int> adj[MaxN];
int max_jud[MaxN][MaxN];  // max_jud[x][k] nr min de orase plasate in judetul cu cele mai multe orase din subarb cu rad in x, (judetul cel mai numeros pt un k dat)
                          //  a.i. k orase (inclusiv x) nu sunt plasate inca
int sz[MaxN];             // sz[x] de noduri din subarborele cu radacina in x

int n, K;

void ReadData()
{
	scanf ("%d%d", &n, &K);
	int a, b;
	for (int i = 1; i < n; i++)
	{
		scanf ("%d%d", &a, &b);
		adj[a].push_back(b);
		adj[b].push_back(a);
	}
}

int v[MaxN];
int C[2 * MaxN];

void Df(int x)
{
	v[x] = 1;
	sz[x] = 1;
	for (const int& f : adj[x])
		if ( !v[f] )
			Df(f), sz[x] += sz[f]; // rezolv pentru fii mai intai

	memset(max_jud[x], 1, sizeof(max_jud[x])); // setat pe infinit

	max_jud[x][1] = 0;  // daca e frunza (si nu o plasez)

	for (const int& f : adj[x])
		if (v[f] == 2) // evit sa merg spre tata
		{
			memset(C, 1, sizeof(C));   //  vector auxiliar setat pe infinit
			for (int j = 0; j <= sz[x]; j++)      // in x am j noduri neplasate
				for (int k = 0; k <= sz[f]; k++)   // in fiul f am k noduri neplasate
					if (j + k <= n)        // cream un alt judet (subarbore care-l contine pe x)
					{			           // din configuratia (f, k) sau le adaugam la alte noduri libere(neplasate)
								           // si trecem in configuratia  (x, j + k)

						// am un arbore cu j noduri din x si k din fiu, care nu este partitionat pe judete
						C[j + k] = min(C[j + k], max(max_jud[x][j], max_jud[f][k]));

						                   // plasez cele k noduri intr-un singur arbore separat - nu combin j si k
						if (k >= K)       // daca k noduri din fiu pot forma singure un arbore
							C[j] = min(C[j], max({max_jud[x][j], max_jud[f][k], k}));
					}
			memcpy(max_jud[x], C, sizeof(C));
		}
	v[x] = 2; // am rezolvat x
}

void WriteData()
{
	int T = 1 << 20;
	for (int i = K; i <= n; i++)
		T = min(T, max(max_jud[1][i], i));

	printf ("%d\n", T);
}

int main()
{
	freopen("9-JUDETE.IN", "r", stdin);
	freopen("judete.out", "w", stdout);

	ReadData();
	Df(1);
	WriteData();
	return 0;
}

