// Time complexity O(n^3)
// OK
#include <stdio.h>
#include <vector>
#include <algorithm>
using namespace std;

ifstream fin("judete.in");
ofstream fout("judete.out");

const int MaxN = 128, Inf = 0x3f3f3f3f;
using VI = vector<int>;

VI adj[MaxN];
VI v, sz;      // sz[x] de noduri din subarborele cu radacina in x
int n, K;

void ReadData();
void WriteData();

int main()
{
	ReadData();
	WriteData();
 	return 0;
}

VI Df(int x)
{
	v[x] = sz[x] = 1;
	VI tx(n + 1, Inf);    // tx[j] -  nr minim de orase in judetul cel mai numeros astfel incat j orase (inclusiv x) nu sunt plasate inca
	tx[1] = 0;  // daca e frunza (si nu o plasez) atunci nu mai am orase plasate in niciun judet

	for (const int& f : adj[x])
	{
		if (v[f]) continue;
		VI tf = Df(f);  /// tf[k] = nr de orase din judetul cel mai numeros
		sz[x] += sz[f]; /// din subarborele cu rad in f

		VI C(n + 1, Inf);
		for (int j = 0; j <= sz[x]; j++)                        // j neplasate in x
			for (int k = 0; k <= sz[f] && j + k <= sz[x]; k++)  // k neplasate in f
			{
				C[j + k] = min(C[j + k], max(tx[j], tf[k]));    // nu creez un judet (arbore) din j si k
				if (k >= K)
					C[j] =  min(C[j], max({tx[j], tf[k], k})); // creez un judet cu k noduri din fiu (raman j neplasate in total)
			}
		tx = C;
	}
	return tx;
}

void WriteData()
{
	int T = 1 << 20;
	VI t = Df(1);
	for (int i = K; i <= n; i++)
		T = min(T, max(t[i], i));

	printf ("%d\n", T);
}

void ReadData()
{
	fin >> n >> K;
	v = sz = VI(n + 1);
	int a, b;
	for (int i = 1; i < n; i++)
	{
		fin >> x >> y;
		adj[x].push_back(y);
		adj[y].push_back(x);
	}
}
