#include <iostream>
#include <cstring>
#include <vector>
#include <algorithm>
using namespace std;


class PickGuitars {
private:
	vector<int> v;     // valorile chitarelor dupa ce se taie cercul
	int vmax[60][60];  /// vmax[l][r] - val maxima care poate fi aleasa de un jucator pe un interval v[l...r]
	int n;
	int total;
	int res;

public:
	int maxValue(vector<int> val)
	{
		n = val.size();
		v.resize(n);
		res = -1;
		total = 0; /// val maxima pe care o obtine primul jucator
		int sum = 0;

		for (int i = 0; i < n; ++i)
			sum += val[i];

		for (int i = 0; i < n; ++i)  // se alege chitara i la primul pas
		{
			for (int j = (i + 1) % n, k = 0; i != j; j = (j + 1) % n)
				v[k++] = val[j]; /// toate valorile in afara de v[i]

			memset(vmax, -1, sizeof(vmax));
			                                        // la pasul 2, pt al doilea jucator
			res = max(res, sum - GetMax(0, n - 2)); // mai sunt n - 1 chitare
		}        // primul jucator are totalul sum - maimul luat de openent
		return res;
	}

	int GetMax(int l, int r) // eu
	{
		if (l > r)	return 0;
		if (vmax[l][r] != -1) // valoarea maxima pt intervalul v[l, r] a fost obtinuta anterior
			return vmax[l][r];

		int total = 0;
		for (int i = l; i <= r; ++i )
			total += v[i];

		int ret = -1;
		for (int i = l; i <= r; ++i)  // jucatorul curent alege chitara v[i]
			ret = max(ret, total - GetMax(l, i - 1) - GetMax(i + 1, r));   // celalalt alege din doua grupuri
                                     // Nicu            Nicu
		return vmax[l][r] = ret;
	}
};

int main()
{
	vector<int> v = {2, 1, 4, 1, 2, 1, 8, 1}; // {4,8,4}; //{1, 5, 3, 4, 5};
	cout << PickGuitars().maxValue(v);
}
